Item = function(){
	this.name = "";
	this.description = "";
}

Item.prototype.pickUp = function(){

}

Item.prototype.getSsIndex = function(){
	return this.ssIndex;
}

Item.prototype.getName = function(){
	return this.name;
}

Item.prototype.getDescription = function(){
	return this.description;
}

Item.prototype.draw= function(i,j){
	ssl = ssLocation(this.getSsIndex());
	ctx.drawImage(ss,ssl[0],ssl[1],16,16,i*tileSize,j*tileSize,tileSize,tileSize);
	
	/*
	not sure about this
	
	if(this.type=="sword" || this.type=="shield" || this.type=="armor"){
		ssl = ssLocation(82+this.value);
		ctx.drawImage(ss,ssl[0],ssl[1],16,16,i*tileSize,j*tileSize,tileSize,tileSize);
	}*/
}

function Gold(tile){
	Item.call(this);

	this.tile = tile;
	this.ssIndex = 64;	
	this.type = "gold";	
	this.name = "Gold Pieces";
	this.description = "You're far more likely to find something to buy something in Stritiba than here. But who doesn't like collecting money?";
	
	this.amount = map.randRange(10,50)*(tile.level.index+1);
}

Gold.prototype = new Item();
Gold.prototype.constructor = Item;

Gold.prototype.pickUp = function(){
	player.gold += this.amount;
	game.playSound("gold");
	return true;
}

Gold.prototype.getName = function(){
	return this.amount+" gold pieces";
}


materialTypes=[
	"Ancient",
	"Gold",
	"Copper",
	"Bronze",
	"Iron",
	"Steel",
	"Emerald",
	"Ruby",
	"Diamond"
];


function Sword(tile){
	Item.call(this);

	this.tile = tile;
	
	this.type = "sword";	
	this.name = "Sword";
	
	this.value = map.pickLevel(tile.level.index)+1;

	//having +1 stuff really sucks
	if(this.value==1 && Math.random()<.75){
		this.value=2;
	}
	
	this.ssIndex = 112+(this.value-1);	
	
	this.description = "A sword. It has a pointy end and two sharp edges, so it can be used to cut up, down, left, or right. Vampires cannot wield this.";
	
}

Sword.prototype = new Item();
Sword.prototype.constructor = Item;

Sword.prototype.getName = function(){
	return materialTypes[(this.value-1)]+" sword (+"+this.value+")";
}

Sword.prototype.pickUp = function(){
	if(this.value>player.sword){
		player.sword = this.value;
		game.log("You pick up the "+this.getName()+", as it's better than what you have now.");
	}else{
		game.log("You find the "+this.getName()+" lacking and discard it.");
	}
	this.tile.item=null;
	return false;
}


function Shield(tile){
	Item.call(this);

	this.tile = tile;
	this.type = "shield";	
	this.name = "Shield";
	
	this.value = map.pickLevel(tile.level.index)+1;

	//having +1 stuff really sucks
	if(this.value==1 && Math.random()<.75){
		this.value=2;
	}
	
	this.ssIndex = 128+(this.value-1);
	
	this.description = "A large shield. Vampires cannot wield this."; 
}

Shield.prototype = new Item();
Shield.prototype.constructor = Item;

Shield.prototype.getName = function(){
	return materialTypes[(this.value-1)]+" shield (+"+this.value+")";
}

Shield.prototype.pickUp = function(){
	if(this.value>player.shield){
		player.shield = this.value;
		game.log("You pick up the "+this.getName()+", as it's better than what you have now.");
	}else{
		game.log("You find the "+this.getName()+" lacking and discard it.");
	}
	this.tile.item=null;
	return false;
}



function Armor(tile){
	Item.call(this);

	this.tile = tile;
	this.type = "armor";	
	this.name = "Armor";
	
	this.value = map.pickLevel(tile.level.index)+1;

	//having +1 stuff really sucks
	if(this.value==1 && Math.random()<.75){
		this.value=2;
	}
	
	this.ssIndex = 144+(this.value-1);
	
	this.description = "A finely made heavy armor wearable by humans or vampires.";
}

Armor.prototype = new Item();
Armor.prototype.constructor = Item;

Armor.prototype.getName = function(){
	return materialTypes[(this.value-1)]+" armor (+"+this.value+")";
}

Armor.prototype.pickUp = function(){
	if(this.value>player.armor){
		player.armor = this.value;
		game.log("You pick up the "+this.getName()+", as it's better than what you have now.");
	}else{
		game.log("You find the "+this.getName()+" lacking and discard it.");
	}
	this.tile.item=null;
	return false;
	
}







function Blood(tile){
	Item.call(this);

	this.tile = tile;
	this.ssIndex = 75;	
	this.type = "blood";	
	this.name = "Blood";
	
	this.health = 0;
	this.removeCounter = 4;
	
	this.description = "A pool of blood. Disgusting or delicious depending on your perspective. Either way, it will dry up soon.";
}

Blood.prototype = new Item();
Blood.prototype.constructor = Item;

Blood.prototype.pickUp = function(){
	if(player.isVampire()){
		this.tile.item=null;
		if(player.poison <= 0){
			game.log("You slurp up the delicious blood.");
			player.health = Math.min(player.maxHealth, player.health+this.health);
		}else{
			game.log("You drink the blood from the floor but find it strangely unsatisfying.");
		}
	}else{
		game.log("Gross! You'll have to clean your boots later.");
	}

	return false;
}



function Ring(tile, ringType){
	Item.call(this);
	this.tile = tile;
	this.type == "ring";

	this.ringType = ringType;
}
Ring.prototype = new Item();
Ring.prototype.constructor = Item;

Ring.prototype.pickUp = function(){
	game.ringsCollected++;
	player.gold+=2500;
	game.playSound("gold");
	return true;
}

Ring.prototype.getSsIndex = function(){
	return 163+this.ringType;
}

Ring.prototype.getName = function(){
	if(this.ringType == 0){
		return "Memento Mori Ring";
	}else if(this.ringType == 1){
		return "Ecclasiastical Ring";
	}else if(this.ringType == 2){
		return "Sovereign Ring";
	}else if(this.ringType == 3){
		return "Signet Ring";
	}
}
Ring.prototype.getDescription = function(){
	if(this.ringType == 0){
		return "A magical gold ring bearing the design of a human skull.";
	}else if(this.ringType == 1){
		return "A magical gold ring with a gemstone, presumably connoting some religious message.";
	}else if(this.ringType == 2){
		return "A magical gold ring engraved with the profile of a vampire. Perhaps it is Fane or King Serafim, but you're not sure.";
	}else if(this.ringType == 3){
		return "A magical gold ring engraved with a coat of arms.";
	}
}
//get name, description, ssindex



function Essence(tile){
	Item.call(this);

	this.tile = tile;
	this.ssIndex = 70;	
	this.type = "essence";	
	this.name = "Essence";
}

Essence.prototype = new Item();
Essence.prototype.constructor = Item;

Essence.prototype.pickUp = function(){
	return true;
}






function Potion(tile){
	Item.call(this);

	this.tile = tile;
	this.ssIndex = 69;	
	this.type = "potion";	
	this.name = "Potion";

	var r = Math.random();
	
	if(r<.175){
		this.potionType = 10;
	}else if(r<.30){
		this.potionType = 9;
	}else if(r<.35){
		this.potionType = map.randRange(0,4);
	}else{
		this.potionType = map.randRange(0,19);
	}
}

Potion.prototype = new Item();
Potion.prototype.constructor = Item;

Potion.prototype.pickUp = function(){
	player.addPotion(potions.potionObjects[this.potionType].name);
	return true;
}

Potion.prototype.getName = function(){
	return potions.getPotionName(potions.potionObjects[this.potionType].name);
}

Potion.prototype.getDescription = function(){
	return potions.getDescription(potions.potionObjects[this.potionType].name);
}

Potion.prototype.identified = function(){
	return potions.identified(potions.potionObjects[this.potionType].name);
}

potions = {
	init:function(){
		for(var i=0;i<potions.potionObjects.length;i++){
			var name = potions.potionObjects[i].name;
			if(name=="Ale" || name=="Oil"){
				potions.potionObjects[i].identify = 6;
			}else if(name=="Soul Elixir"){
				potions.potionObjects[i].identify = 4;
			}else{
				potions.potionObjects[i].identify = 6+map.randRange(0,4);
			}
			potions.potionObjects[i].menuOrder = Math.random();
		}
	},
	getPotionName:function(potionName){
		if(potions.identified(potionName)){
			return potions.getPotion(potionName).name;
		}else{
			return "Unidentified Potion";
		}
	},
	getDescription:function(potionName){
		if(potions.identified(potionName)){
			return potions.getPotion(potionName).description;
		}else{
			return "It's a liquid alright. No telling what effect is has.";
		}
	},
	identified: function(potionName){
		var identify = potions.getPotion(potionName).identify;
		if(player.getTotalIntelligence()>=identify){
			return true;
		}else{
			return false;
		}
	},
	getPotion:function(potionName){
		for(var i=0;i<potions.potionObjects.length;i++){
			if(potions.potionObjects[i].name==potionName){
				return potions.potionObjects[i];
			}
		}
		return null;
	},
	potionObjects:[{
		name: "Curry Noodle Soup",
		description: "Food of the gods. Pork, potatoes, tofu, and noodles. Spicy as hell. Provides an unbelievable amount of sustenance for humans.",
		quaff:function(){
			if(!player.isVampire()){
				player.hunger=Math.min(100,player.hunger+90);
				game.log("Yum.");
			}else{
				game.log("Nothing appears to happen.");
			}
		}
	},
	{
		name: "Milk",
		description: "It's milk. From a mammal of some sort. Provides a moderate amount of sustenance for humans.",
		quaff:function(){
			if(!player.isVampire()){
				player.hunger=Math.min(100,player.hunger+70);
				game.log("Yum.");
			}else{
				game.log("Nothing appears to happen.");
			}
		}
	},
	{
		name: "Honey",
		description: "This is quite nutritious. Provides a large amount of sustenance for humans.",
		quaff:function(){
			if(!player.isVampire()){
				player.hunger=Math.min(100,player.hunger+80);
				game.log("Yum.");
			}else{
				game.log("Nothing appears to happen.");
			}
		}
	},
	{
		name: "Ale",
		description: "A rich, dark ale. Provides a small amount of sustenance for humans.",
		quaff:function(){
			if(!player.isVampire()){
				player.hunger=Math.min(100,player.hunger+60);
				game.log("Yum.");
			}else{
				game.log("Nothing appears to happen.");
			}
		}
	},
	{
		name: "Wine",
		description: "It's not your favorite, but at least it's a red. Provides a tiny amount of sustenance for humans.",
		quaff:function(){
			if(!player.isVampire()){
				player.hunger=Math.min(100,player.hunger+50);
				game.log("Yum.");
			}else{
				game.log("Nothing appears to happen.");
			}
			
			
			//todo: add dumb counter
		}
	},
	{
		name: "Health Potion",
		description: "Heals humans.",
		quaff:function(){
			if(!player.isVampire() && player.poison <= 0){
				player.health=Math.min(player.maxHealth,player.health+50);
			}else{
				game.log("Nothing appears to happen.");
			}
		}
	},
	{
		name: "Strength Boost",
		description: "Temporarily increases your strength.",
		quaff:function(){
			player.strengthBoost+=4;
			game.log("You feel an ephemeral power.");
		}
	},
	{
		name: "Dexterity Boost",
		description: "Temporarily increases your dexterity.",
		quaff:function(){
			player.dexterityBoost+=4;
			game.log("You feel an ephemeral quickness.");
		}
	},
	{
		name: "Intelligence Boost",
		description: "Temporarily increases your intelligence.",
		quaff:function(){
			player.intelligenceBoost+=4;
			game.log("You feel an ephemeral cleverness.");
		}
	},
	{
		name: "Blood",
		description: "Heals vampires and turns vampires who have temporarily transformed into human form back into vampires.",
		quaff:function(){
			if(player.isVampire()){
				if(player.poison <= 0){
					player.health=Math.min(player.maxHealth,player.health+30);
					game.log("Delicious!");
				}else{
					game.log("Think doesn't taste very good while poisoned, nor does it have any effect.");
				}
			}
			player.vampirism = Math.max(100,player.vampirism+50);
		}
	},
	{
		name: "Soul Elixir",
		description: "Temporarily transforms vampires into humans.",
		quaff:function(){
			player.vampirism=0;
			game.log("You feel more like yourself.");
		}
	},
	{
		name: "Wolfsbane",
		description: "A strong poison, but vampires are immune to it.",
		quaff:function(){
			if(!player.isVampire()){
				player.health=Math.max(0,player.health-30);
				player.poison = 4;
				game.log("Ugh! That tastes awful.");
			}else{
				game.log("Nothing appears to happen.");
			}
		}
	},
	{
		name: "Silver",
		description: "Vampires are allergic to this.",
		quaff:function(){
			if(player.isVampire()){
				player.health=Math.max(0,player.health-30);
				game.log("Ugh! That tastes awful.");
			}else{
				game.log("Nothing appears to happen.");
			}
		}
	},
	{
		name: "Oil",
		description: "Torch oil.",
		quaff:function(){
			game.log("Nothing appears to happen.");
		}
	},
	{
		name: "Unholy Essence",
		description: "A potent magical elixir that, for a short time, largely nullifies the effect of nearby light.",
		quaff:function(){
			player.unholy = map.randRange(8,17)+1;
			game.log("It suddenly becomes very dark.");
		}
	},
	{
		name: "Celestial Essence",
		description: "A potent magical elixir that, for a very short time, floods the nearby area in sunlight.",
		quaff:function(){
			player.celestial = map.randRange(2,3)+1;
			game.log("It suddenly becomes very bright.");
		}
	},
	{
		name: "Revealing Essence",
		description:"A magical elixir that grants those who consume it knowledge of their surroundings.",
		quaff: function(){
			for(var i=0;i<map.getCurrentLevel().levelSize;i++){
				for(var j=0;j<map.getCurrentLevel().levelSize;j++){
					var tile=map.getTile(i,j);
					tile.explored = true;
				}
			}
			game.log("You feel a sudden awareness.");
		}
	},
	{
		name: "Antidote",
		description: "A remedy for poison.",
		quaff: function(){
			if(player.poison>0){
				player.poison = 0;
				game.log("Your poisoning subsides.");
			}else{
				game.log("Nothing appears to happen.");
			}
		}
	},
	{
		name: "Henbane",
		description:"A strong hallucinogen.",
		quaff: function(){
			player.hallucinate = 4;
			game.log("You feel confused...");
		}
	},
	{
		name: "Dogbane",
		description:"This is a mild poison, but it affects both vampire and human.",
		quaff: function(){
			player.poison = Math.min(player.poison+2,4);
			game.log("Ugh! That tastes awful.");
		}
	}]
}



books = {
	bookSpells:[
		"blast",
		"heal",
		"silver",
		"firestorm",
		"ice",
		"shock",
		"glow",
		"vitalise",
		"detect"
	],
	chronicles:[
		{
			name: 'On the Mortality of Vampires',
			content: "It's a myth that vampires cannot be killed through conventional means. They don't face old age, but they can die in many ways. What supports this perennial myth? It can likely be attributed to the vampire's unnatural power and agility. They seem to escape death so easily that they appear immortal. Like humans, vampires can be starved. As a battlefield technique, however, starving vampires of blood is not particularly practical. Silver is one option. Magic bolts of silver have been recorded to melt vampire flesh faster than any other method. For professional vampire hunters, light is the tried and true approach. It works 100% of the time. Except after sunset. When fighting vampires, whatever you do, always stay out of the darkness. That is where vampires creep."
		},
		{
			name:"A Short History of the Third Sangian War - Volume I",
			content:"Vampires and humans have warred for all of recorded history, but the Sangian wars were more widespread and politically complex than previous wars. The Third Sangian war was short, lasting only five years. The start of the war can be traced back to a time when the vampire prince Fane publically cut ties with his father, King Serafim, and started attacking the human capital. The king was firmly against breaking the pact established after the Second Sangian War. Who knows why the prince broke away from the old guard? Perhaps, after 180 years of Serafim's rule, Fane simply grew desperate to make a name for himself."
		},
		{
			name:"A Short History of the Third Sangian War - Volume II",
			content:"Fane's attack on the capital was unexpected and it resulted in human casualties, but it seemed unlikely to make headway against such a fortified city. The following week, however, it was revealed that Fane had allied himself with an insurgent faction of humans and he soon helped them execute an overthrow of the established human king. With the king having fled and the capital in shambles, a full blown human civil war broke out."
		},
		{
			name:"A Short History of the Third Sangian War - Volume VI",
			content:"The assassinations of Fane's lieutenants described in Volume V turned the tables on the vampire scourge. Still, the vampires continued their random attacks on remote human settlements. Finally, a plan was hatched by the humans that would lead to an utter destruction of the vampire force. At the Battle of Darkcave Hill, the humans waited patiently for the vampire attack at dusk; the vampire attacks were pitifully predictable at this stage of the war. The humans sacrificed the nearby town to the vampires, but doing so allowed them to seal the 'Darkcave' with giant boulders. When the vampires returned to their caves, which they had been using as a camp, the sun rose and almost all of the vampires were burned alive. Fane was one of the few to escape, but with no remaining support from the insurgents or from King Serafim, he was forced into hiding."
		},
		{
			name:"Origins of the 'Golden Krone Hotel'",
			content:"The 'Golden Krone Hotel,' as it is referred to in modern times, has gone by many names. Its origins are not exactly clear. Based on early written records describing its defensive uses, most historians think it was first built as a castle. After being abandoned for some decades, it was then repurposed into a cathedral. It remained a place of worship for several more centuries. Around the turn of the century, as trade in Stritiba started booming, speculators sensed an opportunity and turned the tower into a hotel. Unfortunately, Stritiba descended into chaos during the last two Sangian wars. A border town, Stritiba proved to be a poor choice for hosting wary travelers and the hotel once again fell into disrepair. It was coined the 'Golden Krone Hotel' in recent years based on rumors, surely false, that the ancient vampire relic is held there. Only outlaws rest their heads there now."
		},
		{
			name:"Ancient Vampire Relics - Volume V: The Golden Krone",
			content:"Though most humans have never heard of its existence, no other artifact holds so much renown among vampires. Millenia ago, the first vampire king, B'klijasgk, proved his worth by ransacking human mines and stealing massive amounts of jewels and gold. He hid most of these valuables, but crafted a small fraction of his gold into a krone. Though it holds less significance in the modern era, vampires have often recognized the wielder of this object as their true ruler. The Krone has no magical powers, only legacy."
		}
	]
}




function Book(tile){
	Item.call(this);

	this.tile = tile;
	this.type = "book";	
	this.name = "Book";
	
	//about half should be grimoires
	var r = Math.random();
	if(r<.35){
		this.bookType = 2; 
	}else if(r<.55){
		this.bookType = 0; 
	}else if(r<.85){
		this.bookType = 3; 
	}else{
		this.bookType = 1; 
	}
	
	if(this.bookType == 0){
		this.chronicleType = map.randRange(0,books.chronicles.length-1);
		
		this.description = "A historical record. If you're not into history lessons, you can safely skip this.";
		this.name = "Chronicle";
	}else if(this.bookType == 1){
		
		this.description = "May be used to improve one's innate abilities.";
		this.name = "Manual";
	}else if(this.bookType == 2){
		this.spellType = books.bookSpells[map.randRange(0,books.bookSpells.length-1)];
		
		this.description = "Teaches or increases your aptitude in the spell "+this.spellType.toUpperCase()+".<br><br>";

		this.description += magic.spells[this.spellType].description;


		this.name = "Grimoire";
	}else if(this.bookType == 3){
		
		this.description = "A helpful guide on identifying a particular potion.";
		this.name = "Primer";
	}
}

Book.prototype = new Item();
Book.prototype.constructor = Item;

Book.prototype.pickUp = function(){
	return false;
}

Book.prototype.getSsIndex = function(){
	return 100+this.bookType;
}



Book.prototype.read = function(){
	//types:
	//	0	info
	//	1	stat boost
	//	2	spell
	//	3	
	
	//information:
	//
	
	if(player.isVampire()){
		game.log("You struggle to sound out the first few words. Vampires can't read good.");
	}else{
		if(this.bookType == 0){
			game.showMenu("<h1>"+books.chronicles[this.chronicleType].name+'</h1><p class="history-book">'+books.chronicles[this.chronicleType].content+"</p>");
		}else if(this.bookType == 1){
			player.getTile().item = null;
			
			var statType = map.randRange(0,2);
			if(statType==0){
				game.log("You feel stronger.");
				player.strength++;
			}else if(statType==1){
				game.log("You feel quicker.");
				player.dexterity++;
			}else if(statType==2){
				game.log("You feel more clever.");
				player.intelligence++;
			}
		}else if(this.bookType == 2){
			magic.grimTile = player.getTile();
			magic.tryLearningSpell(this.spellType);
		}else if(this.bookType == 3){
			var potionId = map.randRange(0,19);
			var potionName = potions.potionObjects[potionId].name;
			game.log("This is a primer on "+potionName+". You can now easily recognize vials of "+potionName+".");
			potions.potionObjects[potionId].identify=0;
			player.getTile().item = null;
		}
		
		game.tick(5*50.0/player.getEffectiveDexterity());
	}
}