lighting={
	lightReach:12,
	sunlightAngle: Math.PI * 1.7,
	fakeTorches:[],
	lightIcon: 'light-icon-night',
	initLightRound:function(){
		for(var i=0;i<map.getCurrentLevel().levelSize;i++){
			for(var j=0;j<map.getCurrentLevel().levelSize;j++){
				var tile = map.getTile(i,j);
				
				if(map.getCurrentLevel().index == map.GARDEN_LEVEL && !game.isNight()){
					tile.light = .6;
				}else{
					tile.light = 0;
				}
				tile.lightVisits = {};
			}
		}
	},
	calculateSunlight: function(){
		lighting.fakeTorches = [];
		lighting.sunlightAngle = ((game.getTimeOfDay()/(60*24))*2*Math.PI+Math.PI/2)%(Math.PI*2);	
		if(lighting.sunlightAngle < 0){
			lighting.sunlightAngle += Math.PI*2
		}
		var lights = [];	
		var level = map.getCurrentLevel();


		if(map.getCurrentLevel().index > map.FANE_LEVEL &&
		map.getCurrentLevel().index != map.GARDEN_LEVEL){
			//ain't no sunshine
			lighting.lightIcon = 'light-icon-night';
		}else{
			if(lighting.sunlightAngle > Math.PI *1.25 && lighting.sunlightAngle < Math.PI *1.75){
				for(var i=1;i<level.levelSize-1;i++){
					var tile = map.getTile(i,level.levelSize-1);
					if(tile.penetrated || tile.name == "Glass"){
						lights.push({
							tile: tile,
							angle: lighting.sunlightAngle,
							intensity: 20.0
						});
					}
				}
				
				lighting.lightIcon = 'light-icon-noon';
				
			}else if(lighting.sunlightAngle > Math.PI * 1.75 || lighting.sunlightAngle < 0){
				for(var i=1;i<level.levelSize-1;i++){
					var tile = map.getTile(0,i);
					if(tile.penetrated || tile.name == "Glass"){
						lights.push({
							tile: tile,
							angle: lighting.sunlightAngle,
							intensity: 20.0
						});
					}
				}
				
				lighting.lightIcon = 'light-icon-evening';
				
			}else if(lighting.sunlightAngle > Math.PI *1.0 && lighting.sunlightAngle < Math.PI *1.25){
				for(var i=1;i<level.levelSize-1;i++){
					var tile = map.getTile(level.levelSize-1,i);
					if(tile.penetrated || tile.name == "Glass"){
						lights.push({
							tile: tile,
							angle: lighting.sunlightAngle,
							intensity: 20.0
						});
					}
				}
				
				lighting.lightIcon = 'light-icon-morning';
				
			}else{
				lighting.lightIcon = 'light-icon-night';
			}
		}

		var monsters = map.getCurrentLevel().monsters;
		for(var i=0;i<monsters.length;i++){
			if(monsters[i]!==null && monsters[i].name=="Sunstone Golem" &&
			monsters[i].beam){
				lights.push({
					tile:monsters[i].tile,
					angle: Math.atan2(
						monsters[i].beamTarget.y-monsters[i].tile.j,
						monsters[i].beamTarget.x-monsters[i].tile.i
					),
					intensity: monsters[i].beamAmount
				})
			}
		}

			
		
		for(var i=0;i<lights.length;i++){
			var tile = lights[i].tile;
			
			var fakeTorchAdded = false;

			var lightX = tile.i;
			var lightY = tile.j;
			
			var prevTile = tile;
			
			for(var j=0;j<1000;j++){
				lightX += Math.cos(lights[i].angle)*.5;
				lightY += Math.sin(lights[i].angle)*.5;
				
				indexX = Math.floor(lightX+.5);
				indexY = Math.floor(lightY+.5);
				
				
				
				var currentTile = map.getTile(
					indexX,
					indexY
				);
				
				currentTile.light = lights[i].intensity;
				
				if(tile.i!=currentTile.i || tile.j!=currentTile.j){
					if(currentTile.opaque){
						if((prevTile.i!=currentTile.i || prevTile.j!=currentTile.j) &&
						(prevTile.i!=tile.i || prevTile.j!=tile.j)){
							lighting.fakeTorches.push(new Torch(prevTile, .55));
						}
						break;
					}
				
					if(!fakeTorchAdded){
						fakeTorchAdded = true;
						lighting.fakeTorches.push(new Torch(currentTile, .55));
					}
				}
				
				if(prevTile.i!=currentTile.i || prevTile.j!=currentTile.j){
					prevTile=currentTile;
				}
			}	
			
		}
		
	},
	checkMonsterBurning: function(monster){
		if(monster!==null &&monster.tile==null){
			console.log(monster.name)
		}
		if(monster!==null && monster.tile.light>=20){
			if(monster.type=="vampire" || monster.name=="Ice Golem"){
				if(monster.tile.isNearby(player.getTile())){	
					game.playSound("explosion");
				}
			
				monster.hp-=30;
				if(monster.hp<=0){
					
					
					if(monster.name=="Fane"){	
						monster.tile.effects.push(9);
						game.log("Fane explodes in the sunlight!");
					}else if(monster.name=="Ice Golem"){
						game.log("The Ice Golem melts away.");
					}else{
						game.log(monster.getArticleName(true)+" explodes in the sunlight!");
						monster.tile.effects.push(8);
					}
					
					player.xp+=monster.getXpValue();
					monster.die();
					map.getCurrentLevel().destroyMonster(monster.tile);
				}else{
					if(monster.name=="Ice Golem"){
						game.log("The sunlight causes the Ice Golem to melt somewhat.");
					}else{
						game.log("The sunlight burns "+monster.getArticleName(false)+".");
					}
				}
			}else if(monster.type=="greenman"){
				monster.upgrade();
			}
		}
	},
	checkBurning: function(){
		//kill vampires here
		var monsters = map.getCurrentLevel().monsters;
		for(var i=0;i<monsters.length;i++){
			lighting.checkMonsterBurning(monsters[i]);
		}
		
		if(player.isVampire() && player.getTile().light>=20){
			game.log("The sunlight burns you!");
			player.takeDamage(Math.floor(player.maxHealth/3.0-1));
			player.checkHp();
			
			game.playSound("explosion");
		}
	},
	calculateDynamicLighting:function(){
		var torches = map.getTorches();
		torches = torches.concat(lighting.fakeTorches);

		for(var i=1;i<map.getCurrentLevel().levelSize-1;i++){
			for(var j=1;j<map.getCurrentLevel().levelSize-1;j++){
				var drawX = i;
				var drawY = j;
				var tile=map.getTile(drawX,drawY);

				if(tile.effects.length>0){
					var brightness = 0;
					for(var k=0;k<tile.effects.length;k++){
						if(tile.effects[k]==50){
							brightness+=.1;
						}
						if(tile.effects[k]==51){
							brightness+=.6;
						}
					}
					torches.push(new Torch(tile, brightness));
				}

				if(tile.monster!=null && tile.monster.name=="Hunter"){
					torches.push(new Torch(tile, 1));
				};
			}
		}

		if(player.glow>0){
			torches.push(new Torch(player.getTile(), player.glow));
		}


		var candidates;
		
		for(var i=0;i<torches.length;i++){
			var torchTile = torches[i].tile;
		
			//lighting.dynamicVisit(torchTile, 12);
			
			candidates = [torchTile];
			
			
			var torchId = torchTile.id;
			
			for(var step=lighting.lightReach;step>0;step--){
				var roundCandidates = [];
				for(var j=0;j<candidates.length;j++){
					roundCandidates = roundCandidates.concat(
						lighting.dynamicVisit(torchId,candidates[j],step,torches[i])
					);
				}
				
				candidates = roundCandidates;
			}
		}
		
		
		/*var playerTile = map.getTile(player.x,player.y);
		var playerSurroundingTiles = playerTile.getAllNeighbors();
		playerSurroundingTiles.push(playerTile);
		for(var i=0;i<playerSurroundingTiles.length;i++){
			if(playerSurroundingTiles[i].light < player.visibilityThreshold){
				playerSurroundingTiles[i].light=player.visibilityThreshold;
			}
		}*/
		
		
		var level = map.getCurrentLevel();
		for(var i=0;i<level.monsters.length;i++){
			if(level.monsters[i]!=null && level.monsters[i].type=="moroi"){
				level.monsters[i].tile.light = player.visibilityThreshold;
				moroiTiles = level.monsters[i].tile.getAllNeighbors();
				for(var j=0;j<moroiTiles.length;j++){
					if(moroiTiles[j].monster==null || moroiTiles[j].monster.type!="moroi"){	
						moroiTiles[j].light = 0;
					}
				}
			}
		}
	},
	dynamicVisit:function(torchId, tile,step, torch){
		if(step==0 || torchId in tile.lightVisits) return [];
		
		tile.lightVisits[torchId] = true;
		
		tile.light+=Math.max(0,1-Math.pow((1-step/lighting.lightReach),2))*torch.getApparentIntensity();
		

		if(tile.opaque) return [];

		var returnNeighbors = [];
		var neighbors = tile.getAdjacentNeighbors();
		for(var i=0;i<neighbors.length;i++){
			if(!(torchId in neighbors[i].lightVisits)){
				returnNeighbors.push(neighbors[i]);
			}
		}
		return returnNeighbors;
	}
};